<?php

/**
 * The home manager controller for iskwaf2x.
 *
 */
class iskwaf2xHomeManagerController extends modExtraManagerController
{
    /** @var iskwaf2x $iskwaf2x */
    public $iskwaf2x;


    /**
     *
     */
    public function initialize()
    {
        $this->iskwaf2x = $this->modx->getService('iskwaf2x', 'iskwaf2x', MODX_CORE_PATH . 'components/iskwaf2x/model/');
        parent::initialize();
    }


    /**
     * @return array
     */
    public function getLanguageTopics()
    {
        return ['iskwaf2x:default'];
    }


    /**
     * @return bool
     */
    public function checkPermissions()
    {
        return true;
    }


    /**
     * @return null|string
     */
    public function getPageTitle()
    {
        return $this->modx->lexicon('iskwaf2x');
    }


    /**
     * @return void
     */
    public function loadCustomCssJs()
    {
    

        $this->addCss($this->iskwaf2x->config['cssUrl'] . 'mgr/main.css');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/iskwaf2x.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/misc/utils.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/misc/combo.js');

        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab1/items.grid.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab2/items.grid2.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab3/items.grid3.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab4/items.grid4.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab5/items.grid5.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab6/items.grid6.js');

        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab99/items.grid99.js');

        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab1/items.windows.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab2/items.windows2.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab3/items.windows3.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab4/items.windows4.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab5/items.windows5.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab6/items.windows6.js');

        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/tab99/items.windows99.js');

        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/sections/home.panel.js');
        $this->addJavascript($this->iskwaf2x->config['jsUrl'] . 'mgr/sections/home.js');

        $this->addHtml('<script type="text/javascript">
        iskwaf2x.config = ' . json_encode($this->iskwaf2x->config) . ';
        iskwaf2x.config.connector_url = "' . $this->iskwaf2x->config['connectorUrl'] . '";
        Ext.onReady(function() {MODx.load({ xtype: "iskwaf2x-page-home"});});
        </script>');

    }


    /**
     * @return string
     */
    public function getTemplateFile()
    {
        $this->content .= '<div id="iskwaf2x-panel-home-div"></div>';

        return '';
    }
}