<?php
/**
 * iskwaf2x WAF & Logger Plugin
 *
 * @var modX $modx
 * @var array $scriptProperties
 *
 * @event OnHandleRequest
 */

// 1. Не работаем в админке
if ($modx->context && $modx->context->key === 'mgr') {
    return;
}

// 2. Определяем путь к файлу сервисного класса по стандартам MODX 2
$servicePath = $modx->getOption('core_path') . 'components/iskwaf2x/model/iskwaf2xservice.class.php';

// 3. Проверяем, существует ли файл, и подключаем его
if (!file_exists($servicePath)) {
    $modx->log(modX::LOG_LEVEL_ERROR, '[iskwaf2x] Critical: Service class file not found at: ' . $servicePath);
    return;
}
require_once $servicePath;

// 4. Запускаем сервис в безопасном блоке try/catch
try {
    // Создаем экземпляр сервиса
    $waf = new IskWaf2xService($modx);

    // Вызываем главный метод, который выполнит всю логику
    $waf->run();

} catch (Exception $e) {
    $modx->log(modX::LOG_LEVEL_ERROR, '[iskwaf2x] Service execution failed: ' . $e->getMessage());
}

return;