<?php


$modx->lexicon->load('iskwaf2x:default');


$tplChunkName = $modx->getOption('tpl', $scriptProperties, 'iskwaf2xCaptchaFormTpl');


if (!isset($_SESSION['iskwaf2x_expected_captcha']) || empty($_SESSION['iskwaf2x_expected_captcha'])) {
    $full_captcha_code = '';
    $captcha_total_length = 6;
    for ($i = 0; $i < $captcha_total_length; $i++) {
        $full_captcha_code .= rand(0, 9);
    }
    $_SESSION['iskwaf2x_full_captcha_code'] = $full_captcha_code;

    $task_type = (rand(0, 1) === 0) ? 'first3' : 'last3';
    $_SESSION['iskwaf2x_captcha_task_type'] = $task_type;

    if ($task_type === 'first3') {
        $_SESSION['iskwaf2x_expected_captcha'] = substr($full_captcha_code, 0, 3);
    } else {
        $_SESSION['iskwaf2x_expected_captcha'] = substr($full_captcha_code, -3, 3);
    }
}


$instruction_text = $modx->lexicon('iskwaf2x_captcha_instructions');
if (isset($_SESSION['iskwaf2x_captcha_task_type'])) {
    if ($_SESSION['iskwaf2x_captcha_task_type'] === 'first3') {
        $instruction_text = $modx->lexicon('iskwaf2x_captcha_instruct_first3');
    } elseif ($_SESSION['iskwaf2x_captcha_task_type'] === 'last3') {
        $instruction_text = $modx->lexicon('iskwaf2x_captcha_instruct_last3');
    }
}


$captchaImageUrl = MODX_ASSETS_URL . 'components/iskwaf2x/no_userConnector.php?action=captcha&rand=' . uniqid();


$errorMessage = '';
if (isset($_SESSION['iskwaf2x_captcha_error_message'])) {
    $errorMessage = '<p style="color:red;">' . htmlspecialchars($_SESSION['iskwaf2x_captcha_error_message']) . '</p>';
    unset($_SESSION['iskwaf2x_captcha_error_message']);
}


$homePageId = (int) $modx->getOption('site_start', null, 1);
$homePageUrl = '';
if ($homePageId > 0) {
    $homePageUrl = $modx->makeUrl($homePageId, '', '', 'full');
}
$siteUrl = rtrim($modx->getOption('site_url'), '/') . 'iskwaf2xcaptcha.php/';
if (empty($homePageUrl) || $homePageUrl === $siteUrl || $homePageUrl === '/') {
    $homePageUrl = $siteUrl;
}
$homePageLinkText = $modx->lexicon('iskwaf2x_captcha_goto_home');
$homeLinkOutput = '';
if (!empty($homePageUrl) && $homePageUrl !== '/') {
    $homeLinkOutput = '<p style="margin-top: 20px; font-size: 0.9em;"><a href="' . htmlspecialchars($homePageUrl) . '">' . htmlspecialchars($homePageLinkText) . '</a></p>';
}


$placeholders = [
    'captcha_page_title' => $modx->lexicon('iskwaf2x_captcha_page_title'),
    'error_message'      => $errorMessage,
    'instruction_text'   => htmlspecialchars($instruction_text),
    'original_uri'       => isset($_SESSION['iskwaf2x_captcha_original_uri']) ? htmlspecialchars($_SESSION['iskwaf2x_captcha_original_uri']) : htmlspecialchars($modx->getOption('site_url')),
    'captcha_image_url'  => htmlspecialchars($captchaImageUrl),
    'submit_button_text' => $modx->lexicon('iskwaf2x_captcha_submit_button'),
    'home_page_url'      => htmlspecialchars($homePageUrl),
    'home_page_link_text'=> htmlspecialchars($homePageLinkText),
    'home_link_output'   => $homeLinkOutput
];

return $modx->getChunk($tplChunkName, $placeholders);
