<?php
/**
 * Получение лога + деталей IP для iskwaf2x (MODX2)
 */

class IskWaf2xItemGetProcessor extends modObjectGetProcessor
{
    public $objectType = 'IskWafLog';
    public $classKey = 'IskWafLog';
    public $languageTopics = ['iskwaf2x:default'];
    

    public function process()
    {
        if (!$this->checkPermissions()) {
            return $this->failure($this->modx->lexicon('access_denied'));
        }
        return parent::process();
    }

    public function cleanup()
    {
        $returnArray = $this->object->toArray('', false, false, true);
        $ipAddress = $this->object->get('ip_address');

        if (!empty($ipAddress)) {
            $ipDetail = $this->modx->getObject('IskWafIp2LocationDetail', ['ip_address' => $ipAddress]);
            if ($ipDetail) {
                $ipDetailArray = $ipDetail->toArray();
                foreach ($ipDetailArray as $key => $value) {
                    if ($key !== 'id' && $key !== 'ip_address') {
                        $returnArray['ipdetail_' . $key] = $value;
                    }
                }
            } else {
                $ipDetailFields = [
                    'country_code', 'country_name', 'region_name', 'city_name', 'latitude', 'longitude',
                    'zip_code', 'time_zone', 'cidr', 'asn', 'as_name', 'last_checked'
                ];
                foreach ($ipDetailFields as $fieldKey) {
                    $returnArray['ipdetail_' . $fieldKey] = $this->modx->lexicon('iskwaf_na');
                }
            }
        }
        return $this->success('', $returnArray);
    }
}

return 'IskWaf2xItemGetProcessor';
