<?php

class IskWafRuleRequestUriRemoveProcessor extends modObjectProcessor
{
    public $objectType = 'IskWafRuleRequestUri';
    public $classKey = 'IskWafRuleRequestUri';
    public $languageTopics = ['iskwaf2x'];
    


    /**
     * @return array|string
     */
    public function process()
    {
        if (!$this->checkPermissions()) {
            return $this->failure($this->modx->lexicon('access_denied'));
        }

        $ids = $this->modx->fromJSON($this->getProperty('ids'));
        if (empty($ids)) {
            return $this->failure($this->modx->lexicon('iskwaf2x_item_err_ns'));
        }

        foreach ($ids as $id) {
            /** @var IskWafRuleRequestUri $object */
            if (!$object = $this->modx->getObject($this->classKey, $id)) {
                return $this->failure($this->modx->lexicon('iskwaf2x_item_err_nf'));
            }

            $object->remove();
        }

        return $this->success();
    }

}

return 'IskWafRuleRequestUriRemoveProcessor';