<?php

class IskWafIp2LocationDetailEnableProcessor extends modObjectProcessor
{
    public $objectType = 'IskWafIp2LocationDetail';
    public $classKey = 'IskWafIp2LocationDetail';
    public $languageTopics = ['iskwaf2x'];
    


    /**
     * @return array|string
     */
    public function process()
    {
        if (!$this->checkPermissions()) {
            return $this->failure($this->modx->lexicon('access_denied'));
        }

        $ids = $this->modx->fromJSON($this->getProperty('ids'));
        if (empty($ids)) {
            return $this->failure($this->modx->lexicon('iskwaf2x_item_err_ns'));
        }

        foreach ($ids as $id) {
            $object = $this->modx->getObject($this->classKey, $id);
            if (!$object) {
                return $this->failure($this->modx->lexicon('iskwaf2x_item_err_nf'));
            }
            $object->set('active', 1);
            $object->save();
        }

        return $this->success();
    }

}

return 'IskWafIp2LocationDetailEnableProcessor';
