<?php

class IskWafReportDailyGetListProcessor extends modObjectGetListProcessor
{
    public $objectType = 'IskWafReportDaily';
    public $classKey = 'IskWafReportDaily';
    public $defaultSortField = 'id';
    public $defaultSortDirection = 'DESC';
    


    /**
     * We do a special check of permissions
     * because our objects is not an instances of modAccessibleObject
     *
     * @return boolean|string
     */
    public function beforeQuery()
    {
        if (!$this->checkPermissions()) {
            return $this->modx->lexicon('access_denied');
        }

        return true;
    }


    /**
     * @param xPDOQuery $c
     *
     * @return xPDOQuery
     */
    public function prepareQueryBeforeCount(xPDOQuery $c)
    {
        
        $query = trim($this->getProperty('query'));
        if ($query) {
            $c->where([
                
                
                'name:LIKE' => "%{$query}%",
            ]);
        }

        return $c;
    }


    /**
     * @param xPDOObject $object
     *
     * @return array
     */
    public function prepareRow(xPDOObject $object)
    {
        $array = $object->toArray();
        $array['actions'] = array();

        
        $array['actions'][] = array(
            'cls' => '',
            'icon' => 'icon icon-edit',
            'title' => $this->modx->lexicon('iskwaf2x_item_update'),
            
            'action' => 'updateItem',
            'button' => true,
            'menu' => true,
        );



        
        $array['actions'][] = array(
            'cls' => '',
            'icon' => 'icon icon-trash-o action-red',
            'title' => $this->modx->lexicon('iskwaf2x_item_remove'),
            'multiple' => $this->modx->lexicon('iskwaf2x_items_remove'),
            'action' => 'removeItem',
            'button' => true,
            'menu' => true,
        );

        return $array;
    }

}

return 'IskWafReportDailyGetListProcessor';