iskwaf2x.window.UpdateItem = function (config) {
    config = config || {};
    if (!config.id) {
        config.id = 'iskwaf2x-Item-window-update'; // Позже вы переименуете это в iskwaf2x-Log-window-view
    }
    Ext.applyIf(config, {
        title: _('iskwaf2x_log_view_title'),
        width: 750, // Немного увеличим ширину для новых полей
        autoHeight: true, // Можно заменить на layout: 'form', autoScroll: true, если полей очень много
        fields: this.getFields(config),
        buttons: [{
            text: _('close'),
            scope: this,
            handler: function() { this.hide(); }
        }]
    });
    iskwaf2x.window.UpdateItem.superclass.constructor.call(this, config);
};
Ext.extend(iskwaf2x.window.UpdateItem, MODx.Window, {

    getFields: function (config) {
        // Поля из iskwaf2xLog
        let logFields = [{
            xtype: 'hidden',
            name: 'id'
            // id: config.id + '-id' // id для полей формы не всегда обязательны, если нет конфликтов
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_timestamp'),
            name: 'timestamp',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_ip_address'),
            name: 'ip_address',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_user_id'),
            name: 'user_id',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_username'),
            name: 'username',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_method'),
            name: 'method',
            anchor: '99%'
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_log_request_uri'),
            name: 'request_uri',
            anchor: '99%',
            readOnly: true,
            height: 50
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_log_user_agent'),
            name: 'user_agent',
            anchor: '99%',
            readOnly: true,
            height: 70
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_log_referrer'),
            name: 'referrer',
            anchor: '99%',
            readOnly: true,
            height: 50
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_http_status'),
            name: 'http_status',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_waf_action'),
            name: 'waf_action',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_log_triggered_rule'),
            name: 'triggered_rule',
            anchor: '99%'
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_log_request_body_preview'),
            name: 'request_body_preview',
            anchor: '99%',
            readOnly: true,
            height: 70
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_log_notes'),
            name: 'notes',
            anchor: '99%',
            readOnly: true,
            height: 70
        }];


        // Используем fieldset для визуального разделения
        let ipDetailFields = {
            xtype: 'fieldset',
            title: _('iskwaf2x_ipdetail_title'), // Новый лексикон: "Информация по IP"
            collapsible: true,
            collapsed: false, // По умолчанию развернут или свернут
            autoHeight: true,
            anchor: '99%',
            items: [{
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_country_name'), // Новый лексикон
                name: 'ipdetail_country_name', // Префикс ipdetail_ + имя поля из iskwaf2xIp2LocationDetail
                anchor: '99%'
            }, {
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_region_name'),
                name: 'ipdetail_region_name',
                anchor: '99%'
            }, {
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_city_name'),
                name: 'ipdetail_city_name',
                anchor: '99%'
            }, {
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_asn'),
                name: 'ipdetail_asn',
                anchor: '99%'
            }, {
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_as_name'),
                name: 'ipdetail_as_name',
                anchor: '99%'
            }, {
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_cidr'),
                name: 'ipdetail_cidr',
                anchor: '99%'
            },{
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_latitude'),
                name: 'ipdetail_latitude',
                anchor: '99%'
            },{
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_longitude'),
                name: 'ipdetail_longitude',
                anchor: '99%'
            },{
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_zip_code'),
                name: 'ipdetail_zip_code',
                anchor: '99%'
            }, {
                xtype: 'displayfield',
                fieldLabel: _('iskwaf2x_ipdetail_last_checked'),
                name: 'ipdetail_last_checked',
                anchor: '99%'
            }

            ]
        };


        return logFields.concat(ipDetailFields); // Объединяем поля лога и поля деталей IP
    }
});
Ext.reg('iskwaf2x-Item-window-update', iskwaf2x.window.UpdateItem); // Позже вы переименуете xtype