iskwaf2x.window.CreateItem5 = function (config) {
    config = config || {};
    if (!config.id) {
        config.id = 'iskwaf2x-Item5-window-create';
    }
    Ext.applyIf(config, {
        title: _('iskwaf2x_requesturi_add'),
        width: 550,
        autoHeight: true,
        url: iskwaf2x.config.connector_url,
        action: 'mgr/item5/create',
        fields: this.getFields(config),
        keys: [{
            key: Ext.EventObject.ENTER, shift: true, fn: function () {
                this.submit()
            }, scope: this
        }]
    });
    iskwaf2x.window.CreateItem5.superclass.constructor.call(this, config);
};
Ext.extend(iskwaf2x.window.CreateItem5, MODx.Window, {

    getFields: function (config) {
        return [{
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_requesturirule_uri_pattern'),
            name: 'uri_pattern',
            id: config.id + '-uri_pattern',
            anchor: '99%',
            allowBlank: false,
            height: 80
        }, {
            xtype: 'combo',
            fieldLabel: _('iskwaf2x_requesturirule_pattern_type'),
            name: 'pattern_type',
            hiddenName: 'pattern_type',
            id: config.id + '-pattern_type',
            store: new Ext.data.ArrayStore({
                id: 0,
                fields: ['value', 'display'],
                data: [
                    ['contains', _('iskwaf2x_patterntype_contains')],
                    ['exact', _('iskwaf2x_patterntype_exact')],
                    ['regex', _('iskwaf2x_patterntype_regex')],
                    ['starts_with', _('iskwaf2x_patterntype_starts_with')]
                ]
            }),
            mode: 'local',
            displayField: 'display',
            valueField: 'value',
            triggerAction: 'all',
            editable: false,
            anchor: '99%',
            allowBlank: false,
            value: 'contains'
        }, {
            xtype: 'xcheckbox',
            fieldLabel: '', // Лейбл обычно для чекбоксов не нужен, если есть boxLabel
            boxLabel: _('iskwaf2x_requesturirule_match_query_string'),
            name: 'match_query_string',
            id: config.id + '-match_query_string',
            inputValue: 1,
            checked: false // Schema default is 0
        }, {
            xtype: 'combo',
            fieldLabel: _('iskwaf2x_requesturirule_rule_type'),
            name: 'rule_type',
            hiddenName: 'rule_type',
            id: config.id + '-rule_type',
            store: new Ext.data.ArrayStore({
                id: 0,
                fields: ['value', 'display'],
                data: [
                    ['block', _('iskwaf2x_ruletype_block')],
                    ['allow', _('iskwaf2x_ruletype_allow')],
                    ['captcha', _('iskwaf2x_ruletype_captcha')]
                ]
            }),
            mode: 'local',
            displayField: 'display',
            valueField: 'value',
            triggerAction: 'all',
            editable: false,
            anchor: '99%',
            allowBlank: false,
            value: 'block'
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_requesturirule_description'),
            name: 'description',
            id: config.id + '-description',
            anchor: '99%',
            height: 60,
            allowBlank: true
        }, {
            xtype: 'xcheckbox',
            boxLabel: _('iskwaf2x_requesturirule_active'),
            name: 'active',
            id: config.id + '-active',
            checked: true,
        }];
    },

    loadDropZones: function () {
    }

});
Ext.reg('iskwaf2x-Item5-window-create', iskwaf2x.window.CreateItem5);


iskwaf2x.window.UpdateItem5 = function (config) {
    config = config || {};
    if (!config.id) {
        config.id = 'iskwaf2x-Item5-window-update';
    }
    Ext.applyIf(config, {
        title: _('iskwaf2x_redak'),
        width: 550,
        autoHeight: true,
        url: iskwaf2x.config.connector_url,
        action: 'mgr/item5/update',
        fields: this.getFields(config),
        keys: [{
            key: Ext.EventObject.ENTER, shift: true, fn: function () {
                this.submit()
            }, scope: this
        }]
    });
    iskwaf2x.window.UpdateItem5.superclass.constructor.call(this, config);
};
Ext.extend(iskwaf2x.window.UpdateItem5, MODx.Window, {

    getFields: function (config) {
        return [{
            xtype: 'hidden',
            name: 'id',
            id: config.id + '-id',
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_requesturirule_uri_pattern'),
            name: 'uri_pattern',
            id: config.id + '-uri_pattern',
            anchor: '99%',
            allowBlank: false,
            height: 80
        }, {
            xtype: 'combo',
            fieldLabel: _('iskwaf2x_requesturirule_pattern_type'),
            name: 'pattern_type',
            hiddenName: 'pattern_type',
            id: config.id + '-pattern_type',
            store: new Ext.data.ArrayStore({
                id: 0,
                fields: ['value', 'display'],
                data: [
                    ['contains', _('iskwaf2x_patterntype_contains')],
                    ['exact', _('iskwaf2x_patterntype_exact')],
                    ['regex', _('iskwaf2x_patterntype_regex')],
                    ['starts_with', _('iskwaf2x_patterntype_starts_with')]
                ]
            }),
            mode: 'local',
            displayField: 'display',
            valueField: 'value',
            triggerAction: 'all',
            editable: false,
            anchor: '99%',
            allowBlank: false
        }, {
            xtype: 'xcheckbox',
            fieldLabel: '',
            boxLabel: _('iskwaf2x_requesturirule_match_query_string'),
            name: 'match_query_string',
            id: config.id + '-match_query_string',
            inputValue: 1
        }, {
            xtype: 'combo',
            fieldLabel: _('iskwaf2x_requesturirule_rule_type'),
            name: 'rule_type',
            hiddenName: 'rule_type',
            id: config.id + '-rule_type',
            store: new Ext.data.ArrayStore({
                id: 0,
                fields: ['value', 'display'],
                data: [
                    ['block', _('iskwaf2x_ruletype_block')],
                    ['allow', _('iskwaf2x_ruletype_allow')],
                    ['captcha', _('iskwaf2x_ruletype_captcha')]
                ]
            }),
            mode: 'local',
            displayField: 'display',
            valueField: 'value',
            triggerAction: 'all',
            editable: false,
            anchor: '99%',
            allowBlank: false
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_requesturirule_description'),
            name: 'description',
            id: config.id + '-description',
            anchor: '99%',
            height: 60,
            allowBlank: true
        },{
            xtype: 'xcheckbox',
            boxLabel: _('iskwaf2x_requesturirule_active'),
            name: 'active',
            id: config.id + '-active',
        }];
    },

    loadDropZones: function () {
    }

});
Ext.reg('iskwaf2x-Item5-window-update', iskwaf2x.window.UpdateItem5);