iskwaf2x.grid.Items99 = function (config) {
    config = config || {};
    if (!config.id) {
        config.id = 'iskwaf2x-grid-items99';
    }
    Ext.applyIf(config, {
        url: iskwaf2x.config.connector_url,
        fields: this.getFields(config),
        columns: this.getColumns(config),
        tbar: this.getTopBar(config),
        sm: new Ext.grid.CheckboxSelectionModel(),
        baseParams: {
            action: 'mgr/item99/getList',
        },
        listeners: {
            rowDblClick: function (grid, rowIndex, e) {
                const row = grid.store.getAt(rowIndex);
                this.updateItem(grid, e, row);
            }
        },
        viewConfig: {
            forceFit: true,
            enableRowBody: true,
            autoFill: true,
            showPreview: true,
            scrollOffset: 0,
            getRowClass: function (rec) {
                return !rec.data.active
                    ? 'iskwaf2x-grid-row-disabled'
                    : '';
            }
        },
        paging: true,
        remoteSort: true,
        autoHeight: true,
    });
    iskwaf2x.grid.Items99.superclass.constructor.call(this, config);

    this.store.on('load', function () {
        if (this._getSelectedIds().length) {
            this.getSelectionModel().clearSelections();
        }
    }, this);
};
Ext.extend(iskwaf2x.grid.Items99, MODx.grid.Grid, {
    windows: {},

    getMenu: function (grid, rowIndex) {
        const ids = this._getSelectedIds();
        const row = grid.getStore().getAt(rowIndex);
        const menu = iskwaf2x.utils.getMenu(row.data['actions'], this, ids);
        this.addContextMenuItem(menu);
    },



    updateItem: function (btn, e, row) {
        if (typeof(row) != 'undefined') {
            this.menu.record = row.data;
        }
        else if (!this.menu.record) {
            return false;
        }
        const id = this.menu.record.id;

        MODx.Ajax.request({
            url: this.config.url,
            params: {
                action: 'mgr/item99/get',
                id: id
            },
            listeners: {
                success: {
                    fn: function (r) {
                        const w = MODx.load({
                            xtype: 'iskwaf2x-Item99-window-update',
                            id: Ext.id(),
                            record: r,
                            listeners: {
                                success: {
                                    fn: function () {
                                        this.refresh();
                                    }, scope: this
                                }
                            }
                        });
                        w.reset();
                        w.setValues(r.object);
                        w.show(e.target);
                    }, scope: this
                }
            }
        });
    },

    removeItem: function () {
        const ids = this._getSelectedIds();
        if (!ids.length) {
            return false;
        }
        MODx.msg.confirm({
            title: ids.length > 1
                ? _('iskwaf2x_items_remove')
                : _('iskwaf2x_item_remove'),
            text: ids.length > 1
                ? _('iskwaf2x_items_remove_confirm')
                : _('iskwaf2x_item_remove_confirm'),
            url: this.config.url,
            params: {
                action: 'mgr/item99/remove',
                ids: Ext.util.JSON.encode(ids),
            },
            listeners: {
                success: {
                    fn: function () {
                        this.refresh();
                    }, scope: this
                }
            }
        });
        return true;
    },





    getFields: function () {
        return [
            'id',
            'report_date',
            'total_triggered_events',
            'total_action_block',
            'total_action_captcha',
            'total_action_allow',
            'ip_rules_triggered',
            'ua_rules_triggered',
            'referrer_rules_triggered',
            'uri_rules_triggered',
            'hits_googlebot',
            'hits_bingbot',
            'hits_yandexbot',
            'hits_duckduckbot',
            'hits_baiduspider',
            'hits_applebot',

            'summary_generated_at',
            'actions'
        ];
    },

    getColumns: function () {
        const renderJsonData = function(value) {
            if (value) {
                try {
                    const data = Ext.decode(value);
                    let html = '<ul style="list-style:none; margin:0; padding:0; max-height: 60px; overflow-y: auto;">';
                    if (Array.isArray(data)) {
                        data.forEach(function(item) {
                            html += '<li>';
                            let itemParts = [];
                            for (const key in item) {
                                if (item.hasOwnProperty(key)) {
                                    itemParts.push(Ext.util.Format.htmlEncode(key) + ': ' + Ext.util.Format.htmlEncode(item[key]));
                                }
                            }
                            html += itemParts.join(', ') + '</li>';
                        });
                    } else if (typeof data === 'object') { // Handle simple object case
                        for (const key in data) {
                            if (data.hasOwnProperty(key)) {
                                html += '<li>' + Ext.util.Format.htmlEncode(key) + ': ' + Ext.util.Format.htmlEncode(data[key]) + '</li>';
                            }
                        }
                    } else {
                        html += '<li>' + Ext.util.Format.htmlEncode(String(value)) + '</li>';
                    }
                    html += '</ul>';
                    return html;
                } catch (e) {
                    return Ext.util.Format.htmlEncode(String(value));
                }
            }
            return '';
        };

        return [{
            header: _('id'),
            dataIndex: 'id',
            sortable: true,
            width: 40,
            hidden: true
        }, {
            header: _('iskwaf2x_report_date'),
            dataIndex: 'report_date',
            sortable: true,
            width: 100,
            renderer: Ext.util.Format.dateRenderer(MODx.config.manager_date_format)
        }, {
            header: _('iskwaf2x_report_total_triggered'),
            dataIndex: 'total_triggered_events',
            sortable: true,
            width: 80,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_total_block'),
            dataIndex: 'total_action_block',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_total_captcha'),
            dataIndex: 'total_action_captcha',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_total_allow'),
            dataIndex: 'total_action_allow',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_ip_triggered'),
            dataIndex: 'ip_rules_triggered',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_ua_triggered'),
            dataIndex: 'ua_rules_triggered',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_ref_triggered'),
            dataIndex: 'referrer_rules_triggered',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_uri_triggered'),
            dataIndex: 'uri_rules_triggered',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_googlebot'),
            dataIndex: 'hits_googlebot',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_bingbot'),
            dataIndex: 'hits_bingbot',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_yandexbot'),
            dataIndex: 'hits_yandexbot',
            sortable: true,
            width: 70,
            align: 'right'
        }, {
            header: _('iskwaf2x_report_summary_generated'),
            dataIndex: 'summary_generated_at',
            sortable: true,
            width: 150,
            renderer: Ext.util.Format.dateRenderer(MODx.config.manager_date_format + ' ' + MODx.config.manager_time_format)
        }, {
            header: _('iskwaf2x_grid_actions'),
            dataIndex: 'actions',
            renderer: iskwaf2x.utils.renderActions,
            sortable: false,
            width: 100,
            id: 'actions'
        }];
    },

    getTopBar: function () {
        return ['->', {
            xtype: 'iskwaf2x-field-search',
            width: 250,
            listeners: {
                search: { fn: function (field) { this._doSearch(field); }, scope: this },
                clear: { fn: function (field) { field.setValue(''); this._clearSearch(); }, scope: this },
            }
        }];
    },

    onClick: function (e) {
        const elem = e.getTarget();
        if (elem.nodeName == 'BUTTON') {
            const row = this.getSelectionModel().getSelected();
            if (typeof(row) != 'undefined') {
                const action = elem.getAttribute('action');
                if (action == 'showMenu') {
                    const ri = this.getStore().find('id', row.id);
                    return this._showMenu(this, ri, e);
                }
                else if (typeof this[action] === 'function') {
                    this.menu.record = row.data;
                    return this[action](this, e);
                }
            }
        }
        return this.processEvent('click', e);
    },

    _getSelectedIds: function () {
        const ids = [];
        const selected = this.getSelectionModel().getSelections();

        for (const i in selected) {
            if (!selected.hasOwnProperty(i)) {
                continue;
            }
            ids.push(selected[i]['id']);
        }

        return ids;
    },

    _doSearch: function (tf) {
        this.getStore().baseParams.query = tf.getValue();
        this.getBottomToolbar().changePage(1);
    },

    _clearSearch: function () {
        this.getStore().baseParams.query = '';
        this.getBottomToolbar().changePage(1);
    },
});
Ext.reg('iskwaf2x-grid-items99', iskwaf2x.grid.Items99);