iskwaf2x.window.UpdateItem99 = function (config) {
    config = config || {};
    if (!config.id) {
        config.id = 'iskwaf2x-Item99-window-update';
    }
    Ext.applyIf(config, {
        title: _('iskwaf2x_show_reports'),
        width: 650,
        autoHeight: true,

        fields: this.getFields(config),

        buttons: [{
            text: _('close'),
            scope: this,
            handler: function() { this.hide(); }
        }]
    });
    iskwaf2x.window.UpdateItem99.superclass.constructor.call(this, config);
};
Ext.extend(iskwaf2x.window.UpdateItem99, MODx.Window, {

    getFields: function (config) {
        const originalSetValue = Ext.form.TextArea.prototype.setValue;
        return [{
            xtype: 'hidden',
            name: 'id',
            id: config.id + '-id',
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_date'),
            name: 'report_date',
            id: config.id + '-report_date',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_total_triggered'),
            name: 'total_triggered_events',
            id: config.id + '-total_triggered_events',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_total_block'),
            name: 'total_action_block',
            id: config.id + '-total_action_block',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_total_captcha'),
            name: 'total_action_captcha',
            id: config.id + '-total_action_captcha',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_total_allow'),
            name: 'total_action_allow',
            id: config.id + '-total_action_allow',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_ip_triggered'),
            name: 'ip_rules_triggered',
            id: config.id + '-ip_rules_triggered',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_ua_triggered'),
            name: 'ua_rules_triggered',
            id: config.id + '-ua_rules_triggered',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_ref_triggered'),
            name: 'referrer_rules_triggered',
            id: config.id + '-referrer_rules_triggered',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_uri_triggered'),
            name: 'uri_rules_triggered',
            id: config.id + '-uri_rules_triggered',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_googlebot'),
            name: 'hits_googlebot',
            id: config.id + '-hits_googlebot',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_bingbot'),
            name: 'hits_bingbot',
            id: config.id + '-hits_bingbot',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_yandexbot'),
            name: 'hits_yandexbot',
            id: config.id + '-hits_yandexbot',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_duckduckbot'),
            name: 'hits_duckduckbot',
            id: config.id + '-hits_duckduckbot',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_baiduspider'),
            name: 'hits_baiduspider',
            id: config.id + '-hits_baiduspider',
            anchor: '99%'
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_applebot'),
            name: 'hits_applebot',
            id: config.id + '-hits_applebot',
            anchor: '99%'
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_report_top_ips'),
            name: 'top_blocked_ips_json',
            id: config.id + '-top_blocked_ips_json',
            anchor: '99%',
            readOnly: true,
            height: 100,
            setValue: function(v) {
                let displayValue = v;
                if (typeof v === 'object' && v !== null) {
                    try {
                        displayValue = JSON.stringify(v, null, 2);
                    } catch (e) {
                        displayValue = String(v);
                    }
                } else if (typeof v === 'string') {
                    try {
                        const jsonData = JSON.parse(v);
                        displayValue = JSON.stringify(jsonData, null, 2);
                    } catch (e) {
                        // Оставляем как есть
                    }
                }
                return originalSetValue.call(this, displayValue);
            }
        }, {
            xtype: 'textarea',
            fieldLabel: _('iskwaf2x_report_top_rules'),
            name: 'top_triggering_rules_json',
            id: config.id + '-top_triggering_rules_json',
            anchor: '99%',
            readOnly: true,
            height: 100,
            setValue: function(v) {
                let displayValue = v;
                if (typeof v === 'object' && v !== null) {
                    try {
                        displayValue = JSON.stringify(v, null, 2);
                    } catch (e) {
                        displayValue = String(v);
                    }
                } else if (typeof v === 'string') {
                    try {
                        const jsonData = JSON.parse(v);
                        displayValue = JSON.stringify(jsonData, null, 2);
                    } catch (e) {
                        // Оставляем как есть
                    }
                }
                return originalSetValue.call(this, displayValue);
            }
        }, {
            xtype: 'displayfield',
            fieldLabel: _('iskwaf2x_report_summary_generated'),
            name: 'summary_generated_at',
            id: config.id + '-summary_generated_at',
            anchor: '99%'
        }];
    },

    loadDropZones: function () {
    }

});
Ext.reg('iskwaf2x-Item99-window-update', iskwaf2x.window.UpdateItem99);