<?php

define('MODX_API_MODE', true);
require_once dirname(__FILE__, 4) . '/index.php';

if (!is_object($modx) || !($modx instanceof modX)) {
    require_once dirname(__FILE__, 4) . '/core/model/modx/modx.class.php';
    $modx = new modX();
}
$modx->initialize('web');



// Список разрешённых действий
$allowedActions = ['captcha']; // Только "captcha"

// Получаем action и приводим к нижнему регистру (без точек!)
$action = !empty($_REQUEST['action']) ? strtolower($_REQUEST['action']) : '';

// Проверяем допустимость действия
if (in_array($action, $allowedActions, true)) {
    $path = $modx->getOption('core_path') . 'components/iskwaf2x/processors/web/';
    $processorPath = $path . $action . '.class.php';

    if (file_exists($processorPath)) {
        require_once $processorPath;
    } else {
        echo json_encode(['success' => false, 'message' => 'Processor not found.']);
    }
} else {
    echo json_encode(['success' => false, 'message' => 'Action not allowed.']);
}
